org.springframework.core.codec

## Interface Encoder<T>

- Type Parameters:
    `T` - the type of elements in the input stream
  All Known Subinterfaces:
    HttpMessageEncoder<T>
  All Known Implementing Classes:
    AbstractEncoder, AbstractJackson2Encoder, AbstractSingleValueEncoder, ByteArrayEncoder, ByteBufferEncoder, CharSequenceEncoder, DataBufferEncoder, Jackson2CborEncoder, Jackson2JsonEncoder, Jackson2SmileEncoder, Jaxb2XmlEncoder, KotlinSerializationJsonEncoder, NettyByteBufEncoder, ProtobufEncoder, ResourceEncoder, ResourceRegionEncoder

      public interface Encoder<T>

  Strategy to encode a stream of Objects of type `<T>` into an output stream of bytes.
  Since:
    5.0
  Author:
    Sebastien Deleuze, Rossen Stoyanchev

- - ### Method Summary

    All Methods Instance Methods Abstract Methods Default Methods
    Modifier and Type | Method and Description
    --- | ---
    `boolean` | `canEncode(ResolvableType elementType, MimeType mimeType)` Whether the encoder supports the given source element type and the MIME type for the output stream.
    `reactor.core.publisher.Flux<DataBuffer>` | `encode(Publisher<? extends T> inputStream, DataBufferFactory bufferFactory, ResolvableType elementType, MimeType mimeType, Map<String,Object> hints)` Encode a stream of Objects of type `T` into a `DataBuffer` output stream.
    `default DataBuffer` | `encodeValue(T value, DataBufferFactory bufferFactory, ResolvableType valueType, MimeType mimeType, Map<String,Object> hints)` Encode an Object of type T to a data buffer.
    `List<MimeType>` | `getEncodableMimeTypes()` Return the list of MIME types supported by this Encoder.
    `default List<MimeType>` | `getEncodableMimeTypes(ResolvableType elementType)` Return the list of MIME types supported by this Encoder for the given type of element.

- - ### Method Detail

    - #### canEncode

          boolean canEncode(ResolvableType elementType,
                            @Nullable
                            MimeType mimeType)

      Whether the encoder supports the given source element type and the MIME type for the output stream.
      Parameters:
        `elementType` - the type of elements in the source stream
        `mimeType` - the MIME type for the output stream (can be `null` if not specified)
      Returns:
        `true` if supported, `false` otherwise

    - #### encode

          reactor.core.publisher.Flux<DataBuffer> encode(Publisher<? extends T> inputStream,
                                                         DataBufferFactory bufferFactory,
                                                         ResolvableType elementType,
                                                         @Nullable
                                                         MimeType mimeType,
                                                         @Nullable
                                                         Map<String,Object> hints)

      Encode a stream of Objects of type `T` into a `DataBuffer` output stream.
      Parameters:
        `inputStream` - the input stream of Objects to encode. If the input should be encoded as a single value rather than as a stream of elements, an instance of `Mono` should be used.
        `bufferFactory` - for creating output stream `DataBuffer`'s
        `elementType` - the expected type of elements in the input stream; this type must have been previously passed to the `canEncode(org.springframework.core.ResolvableType, org.springframework.util.MimeType)` method and it must have returned `true`.
        `mimeType` - the MIME type for the output content (optional)
        `hints` - additional information about how to encode
      Returns:
        the output stream

    - #### encodeValue

          default DataBuffer encodeValue(T value,
                                         DataBufferFactory bufferFactory,
                                         ResolvableType valueType,
                                         @Nullable
                                         MimeType mimeType,
                                         @Nullable
                                         Map<String,Object> hints)

      Encode an Object of type T to a data buffer. This is useful for scenarios, that distinct messages (or events) are encoded and handled individually, in fully aggregated form.

      By default this method raises `UnsupportedOperationException` and it is expected that some encoders cannot produce a single buffer or cannot do so synchronously (e.g. encoding a `Resource`).

      Parameters:
        `value` - the value to be encoded
        `bufferFactory` - for creating the output `DataBuffer`
        `valueType` - the type for the value being encoded
        `mimeType` - the MIME type for the output content (optional)
        `hints` - additional information about how to encode
      Returns:
        the encoded content
      Since:
        5.2

    - #### getEncodableMimeTypes

          List<MimeType> getEncodableMimeTypes()

      Return the list of MIME types supported by this Encoder. The list may not apply to every possible target element type and calls to this method should typically be guarded via `canEncode(elementType, null)`. The list may also exclude MIME types supported only for a specific element type. Alternatively, use `getEncodableMimeTypes(ResolvableType)` for a more precise list.
      Returns:
        the list of supported MIME types

    - #### getEncodableMimeTypes

          default List<MimeType> getEncodableMimeTypes(ResolvableType elementType)

      Return the list of MIME types supported by this Encoder for the given type of element. This list may differ from the `getEncodableMimeTypes()` if the Encoder doesn't support the element type or if it supports it only for a subset of MIME types.
      Parameters:
        `elementType` - the type of element to check for encoding
      Returns:
        the list of MIME types supported for the given element type
      Since:
        5.3.4